---
title: Object.getOwnPropertyDescriptors()
slug: Web/JavaScript/Reference/Global_Objects/Object/getOwnPropertyDescriptors
tags:
  - JavaScript
  - Method
  - Object
---
<div>{{JSRef}}</div>

<p>The <code><strong>Object.getOwnPropertyDescriptors()</strong></code> method returns all own property descriptors of a given object.</p>

<div>{{EmbedInteractiveExample("pages/js/object-getownpropertydescriptors.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Object.getOwnPropertyDescriptors(<var>obj</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>obj</code></dt>
 <dd>The object for which to get all own property descriptors.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An object containing all own property descriptors of an object. Might be an empty object, if there are no properties.</p>

<h2 id="Description">Description</h2>

<p>This method permits examination of the precise description of all own properties of an object. A <dfn>property</dfn> in JavaScript consists of either a string-valued name or a {{jsxref("Symbol")}} and a property descriptor. Further information about property descriptor types and their attributes can be found in {{jsxref("Object.defineProperty()")}}.</p>

<p>A <dfn>property descriptor</dfn> is a record with some of the following attributes:</p>

<dl>
 <dt><code>value</code></dt>
 <dd>The value associated with the property (data descriptors only).</dd>
 <dt><code>writable</code></dt>
 <dd><code>true</code> if and only if the value associated with the property may be changed (data descriptors only).</dd>
 <dt><code>get</code></dt>
 <dd>A function which serves as a getter for the property, or {{jsxref("undefined")}} if there is no getter (accessor descriptors only).</dd>
 <dt><code>set</code></dt>
 <dd>A function which serves as a setter for the property, or {{jsxref("undefined")}} if there is no setter (accessor descriptors only).</dd>
 <dt><code>configurable</code></dt>
 <dd><code>true</code> if and only if the type of this property descriptor may be changed and if the property may be deleted from the corresponding object.</dd>
 <dt><code>enumerable</code></dt>
 <dd><code>true</code> if and only if this property shows up during enumeration of the properties on the corresponding object.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_shallow_clone">Creating a shallow clone</h3>

<p>Whereas the {{jsxref("Object.assign()")}} method will only copy enumerable and own properties from a source object to a target object, you are able to use this method and {{jsxref("Object.create()")}} for a shallow copy between two unknown objects:</p>

<pre class="brush: js notranslate">Object.create(
  Object.getPrototypeOf(obj),
  Object.getOwnPropertyDescriptors(obj)
);
</pre>

<h3 id="Creating_a_subclass">Creating a subclass</h3>

<p>A typical way of creating a subclass is to define the subclass, set its prototype to an instance of the superclass, and then define properties on that instance. This can get awkward especially for getters and setters. Instead, you can use this code to set the prototype:</p>

<pre class="brush: js notranslate">function superclass() {}
superclass.prototype = {
  // Define your methods and properties here
};
function subclass() {}
subclass.prototype = Object.create(
  superclass.prototype,
  {
    // Define your methods and properties here
  }
);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object.getownpropertydescriptors', 'Object.getOwnPropertyDescriptors')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Object.getOwnPropertyDescriptors")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Object.getOwnPropertyDescriptor()")}}</li>
 <li>{{jsxref("Object.defineProperty()")}}</li>
 <li><a href="https://github.com/tc39/proposal-object-getownpropertydescriptors">Polyfill</a></li>
</ul>
